Subject: Re: [PATCH] netlink: don't copy over empty attribute data

From: Sasha Levin <[email-masked]>
Date: Sun, 26 Oct 2014 19:32:42 -0400

On 10/22/2014 02:15 AM, David Miller wrote:
> From: Sasha Levin <[email-masked]>
> Date: Tue, 21 Oct 2014 22:19:36 -0400
> 
>> On 10/21/2014 09:39 PM, David Miller wrote:
>>> From: Sasha Levin <[email-masked]>
>>> Date: Tue, 21 Oct 2014 16:51:09 -0400
>>>
>>>>> netlink uses empty data to seperate different levels. However, we still
>>>>> try to copy that data from a NULL ptr using memcpy, which is an undefined
>>>>> behaviour.
>>>>>
>>>>> Signed-off-by: Sasha Levin <[email-masked]>
>>> This isn't a POSIX C library, this it the Linux kernel, and as such
>>> we can make sure none of our memcpy() implementations try to access
>>> any bytes if the given length is NULL.
>>
>> We can make *our* implementations work around that undefined behaviour if we
>> want, but right now our implementations is to call GCC's builtin memcpy(),
>> which follows the standards and doesn't allow you to call it with NULL 'from'
>> ptr.
>>
>> The fact that it doesn't die and behaves properly is just "luck".
> 
> If GCC's internal memcpy() starts accessing past 'len', I'm going
> to report the bug rather than code around it.

How so? GCC states clearly that you should *never* pass a NULL pointer there:

"The pointers passed to memmove (and similar functions in <string.h>) must
be non-null even when nbytes==0" (https://gcc.gnu.org/gcc-4.9/porting_to.html).

Even if it doesn't dereference it, it can break somehow in a subtle way. Leaving
the kernel code assuming that gcc (or any other compiler) would always behave
the same in a situation that shouldn't occur.

Thanks,
Sasha